//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int         SysTkePftVal=5;
int         SystemMagic1=1;
int         AcountEquity=0;
int         HighesEquity=0;
int         MaxDDCurency=0;
int         BrkEveEquity=0;
int         BrkEveEquTme=0;
int         iBandsNumPip=0;
int         SL__Currency=200;
int         MinPerMinLot=333;
bool        SysCloseMode=false;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
string      SymbolsArray[];
string      CurSetSymbol="";
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void OnInit(){
    MathSrand(GetTickCount());
    string Temporary[]={"EURUSD"};
    /*string Temporary[]={"EURUSD","EURCHF","EURJPY","EURGBP",
                        "USDJPY","USDCHF","USDCAD","GBPUSD","AUDUSD"};*/
    ArrayResize(SymbolsArray,ArraySize(Temporary));
        ArrayCopy(SymbolsArray,Temporary);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void OnTick(){
    if(!YesMinBarOpn()){return;}
    HighesEquity();
    BrkEveEquity();
    MaxDDCurency();
    while(SymbolRayLoop());
    ChartComment();
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ChartComment(){
    Comment(
        "MaxDDCurency=",    MaxDDCurency,"\n",
        "AcountEquity=",    AcountEquity,"\n",
        "HighesEquity=",    HighesEquity,"\n",
        "BrkEveEquity=",    BrkEveEquity
    );
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool SymbolRayLoop(){
    for(int i=0; i<ArraySize(SymbolsArray); i++){
        CurSetSymbol=SymbolsArray[i];
        iBandsNumPip();
        OpenRndPos01();
        OpenConPos01();
        ExiMagPosAll();
        ExiSetSym_SL();
    }   return(false);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void OpenRndPos01(){
    if(SysCloseMode){return;}
    if(AcountEquity>BrkEveEquity){return;}
    if(PositionSelect(CurSetSymbol)){return;}
    Order_Send(RanOrdTypGen(),VolumeSize(),0);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ExiMagPosAll(){
    if(AcountEquity<=BrkEveEquity+SysTkePftVal && !SysCloseMode){return;}
    SysCloseMode=true; if(SysCloseMode){ClsSymSetPos();}
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void OpenConPos01(){
    if(SysCloseMode){return;}
    if(AcountEquity>BrkEveEquity){return;}
    if(!PositionSelect(CurSetSymbol)){return;}
    ulong   PosType=PositionGetInteger(POSITION_TYPE);
    if(YesLstTrdWin()){return;}
    if(LstTrdNowDif()<iBandsNumPip){return;}
    Order_Send(PosType,VolumeSize(),0);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ExiSetSym_SL(){
    if(SysCloseMode){return;}
    if(!PositionSelect(CurSetSymbol)){return;}
    double  PosProf=PositionGetDouble(POSITION_PROFIT);
    if(PosProf>=-SL__Currency){return;}
    ClsSymSetPos();
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool YesMinBarOpn(){
    static datetime BarTime; datetime MinuteOpen[1];
    CopyTime(_Symbol,PERIOD_M1,0,1,MinuteOpen);
    if(BarTime==MinuteOpen[0]){return(false);}
    BarTime=MinuteOpen[0]; return(true);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void HighesEquity(){
    AcountEquity=(int)AccountInfoDouble(ACCOUNT_EQUITY);
    if(AcountEquity<=HighesEquity){return;}
    HighesEquity=AcountEquity;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void BrkEveEquity(){
    if(SysMagTotCnt()!=0){return;}
    BrkEveEquity=HighesEquity;
    BrkEveEquTme=(int)TimeCurrent();
    SysCloseMode=false;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void MaxDDCurency(){
    int TempDD=AcountEquity-HighesEquity;
    if(TempDD>MaxDDCurency){return;}
    MaxDDCurency=TempDD;
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int SysMagTotCnt(){ int Res=0;
    for(int i=0; i<ArraySize(SymbolsArray); i++){
        if(!PositionSelect(SymbolsArray[i])){continue;}
        ulong SymMagic=PositionGetInteger(POSITION_MAGIC);
        if(SymMagic==SystemMagic1){Res++;}
    }   return(Res);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void iBandsNumPip(){
    char MA_Shift=0; uchar Deviation=3; uchar Upon=PRICE_OPEN;
    ENUM_TIMEFRAMES Minute1=PERIOD_M1; int BarsBack=MinPerMinLot;
    int H=iBands(CurSetSymbol,Minute1,BarsBack,MA_Shift,Deviation,Upon);
    ushort BandUpper=1; ushort BandLower=2; iBandsNumPip=0;
    double UpperRay[]; ArraySetAsSeries(UpperRay,true);
    double LowerRay[]; ArraySetAsSeries(LowerRay,true);
    double MidleRay[]; ArraySetAsSeries(MidleRay,true);
    CopyBuffer(H,BandUpper,0,BarsBack,UpperRay);
    CopyBuffer(H,BandLower,0,BarsBack,LowerRay);
    iBandsNumPip=p2i(UpperRay[0]-LowerRay[0]);
    if(iBandsNumPip<5){iBandsNumPip=5;}
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int p2i(double X){
    double Pips=0;
    if(StringFind(CurSetSymbol,"JPY")>-1
    || StringFind(CurSetSymbol,"XAG")>-1
    || StringFind(CurSetSymbol,"XAU")>-1
        ){Pips=0.01;}else{Pips=0.0001;}
    double Result=X/Pips;
    return((int)Result);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ulong RanOrdTypGen(){
    if(MathRand()%2==0){
        return(ORDER_TYPE_BUY);}else{
        return(ORDER_TYPE_SELL);
}   }
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ulong OppositeType(ulong Type){
    if(Type==POSITION_TYPE_BUY){return(ORDER_TYPE_SELL);}
    if(Type==POSITION_TYPE_SELL){return(ORDER_TYPE_BUY);}
    return(WRONG_VALUE);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int BarsM1Shift(datetime xTime){
    int i=0; datetime BarTime[1];
    int BarsM1=Bars(_Symbol,PERIOD_M1);
    for(i=0; i<BarsM1; i++){
        CopyTime(_Symbol,PERIOD_M1,i,1,BarTime);
        if(BarTime[0]<xTime){break;}    } return(i);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
double VolumeSize(){
    double  VolumeSize=0; 
    double  BrkMinLot=SymbolInfoDouble(CurSetSymbol,SYMBOL_VOLUME_MIN);
    double  BrkMaxLot=SymbolInfoDouble(CurSetSymbol,SYMBOL_VOLUME_MAX);
    double  BrkStpLot=SymbolInfoDouble(CurSetSymbol,SYMBOL_VOLUME_STEP);
    /**/
    int BreakEvenShf=BarsM1Shift(BrkEveEquTme);
    VolumeSize=BreakEvenShf/MinPerMinLot*BrkMinLot;
    /**/
    VolumeSize=MathFloor(VolumeSize/BrkStpLot)*BrkStpLot;
    if(VolumeSize<BrkMinLot){VolumeSize=BrkMinLot;}
    if(VolumeSize>BrkMaxLot){VolumeSize=BrkMaxLot;}
    return(VolumeSize);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ulong SymbolSpread(){return(SymbolInfoInteger(CurSetSymbol,SYMBOL_SPREAD));}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ulong SymbolDigits(){return(SymbolInfoInteger(CurSetSymbol,SYMBOL_DIGITS));}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
double p2pip(double X){ulong D=SymbolDigits(); if(D%2==1){X/=10;} return(X);}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void SetTradeRequest(
ENUM_ORDER_TYPE Type,
double Lots,
MqlTradeRequest& Trade,
ulong xTicket
){
    Trade.action=TRADE_ACTION_DEAL;
    Trade.magic=SystemMagic1;
    Trade.symbol=CurSetSymbol;
    Trade.volume=Lots;
    Trade.deviation=0;
    Trade.type=Type;
    Trade.type_filling=ORDER_FILLING_FOK;
    Trade.comment=IntegerToString(xTicket);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void SetTradePrices(ENUM_ORDER_TYPE Type,MqlTradeRequest& Trade){
    if(Type!=ORDER_TYPE_BUY && Type!=ORDER_TYPE_SELL){return;} double Price=0;
    if(Type==ORDER_TYPE_BUY){Price=SymbolInfoDouble(CurSetSymbol,SYMBOL_ASK);}
    if(Type==ORDER_TYPE_SELL){Price=SymbolInfoDouble(CurSetSymbol,SYMBOL_BID);}
    Trade.price=Price;//////////////////////////////////////////
    double  SymPoint=SymbolInfoDouble(CurSetSymbol,SYMBOL_POINT);
    if(Type==ORDER_TYPE_BUY){Trade.sl=SymPoint;  Trade.tp=999999999;}
    if(Type==ORDER_TYPE_SELL){Trade.tp=SymPoint; Trade.sl=999999999;}
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool Order_Send(ulong Type, double Lots, ulong xTicket){
    if(p2pip(SymbolSpread())>2 && xTicket==0){return(false);}
    ENUM_ORDER_TYPE EnumType=(ENUM_ORDER_TYPE)Type;
    MqlTradeRequest   Trade;      ZeroMemory(Trade);
    MqlTradeResult    Result;     ZeroMemory(Result);
    SetTradeRequest(EnumType,Lots,Trade,xTicket);
    SetTradePrices(EnumType,Trade);
    return(OrderSend(Trade,Result));
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
void ClsSymSetPos(){
    if(!PositionSelect(CurSetSymbol)){return;}
    ulong   PosType=PositionGetInteger(POSITION_TYPE);
    double  PosVolume=PositionGetDouble(POSITION_VOLUME);
    Order_Send(OppositeType(PosType),PosVolume,'C');
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
bool YesLstTrdWin(){
    if(!PositionSelect(CurSetSymbol)){return(false);}
    ulong   PosType=PositionGetInteger(POSITION_TYPE);
    ulong   PosOpTime=PositionGetInteger(POSITION_TIME);
    double  PosPrice=PositionGetDouble(POSITION_PRICE_CURRENT);
    HistorySelect(PosOpTime,TimeCurrent());
    int DealsTotal=HistoryDealsTotal();
    for(int i=DealsTotal-1; i>=0; i--){
        ulong DealTicket=HistoryDealGetTicket(i);
        ulong DealEntry=HistoryDealGetInteger(DealTicket,DEAL_ENTRY);
        if(DealEntry!=DEAL_ENTRY_IN){continue;}
        ulong DealMagic=HistoryDealGetInteger(DealTicket,DEAL_MAGIC);
        if(DealMagic!=SystemMagic1){continue;}
        string DealSymb=HistoryDealGetString(DealTicket,DEAL_SYMBOL);
        if(DealSymb!=CurSetSymbol){continue;}
        ulong  DealType=HistoryDealGetInteger(DealTicket,DEAL_TYPE);
        double DealPrice=HistoryDealGetDouble(DealTicket,DEAL_PRICE);
        if(DealType==DEAL_TYPE_BUY && PosPrice>DealPrice){return(true);}
        return(false);
    }   return(false);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
int LstTrdNowDif(){
    if(!PositionSelect(CurSetSymbol)){return(-1);}
    ulong   PosType=PositionGetInteger(POSITION_TYPE);
    ulong   PosOpTime=PositionGetInteger(POSITION_TIME);
    double  PosPrice=PositionGetDouble(POSITION_PRICE_CURRENT);
    HistorySelect(PosOpTime,TimeCurrent());
    int DealsTotal=HistoryDealsTotal();
    for(int i=DealsTotal-1; i>=0; i--){
        ulong DealTicket=HistoryDealGetTicket(i);
        ulong DealEntry=HistoryDealGetInteger(DealTicket,DEAL_ENTRY);
        if(DealEntry!=DEAL_ENTRY_IN){continue;}
        ulong DealMagic=HistoryDealGetInteger(DealTicket,DEAL_MAGIC);
        if(DealMagic!=SystemMagic1){continue;}
        string DealSymb=HistoryDealGetString(DealTicket,DEAL_SYMBOL);
        if(DealSymb!=CurSetSymbol){continue;}
        double DealPrice=HistoryDealGetDouble(DealTicket,DEAL_PRICE);
        int DifInPip=p2i(MathAbs(DealPrice-PosPrice));
        return(DifInPip);
    }   return(-1);
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~